/* publics from term.c */

extern int cols, lines;		/* terminal window size */
extern int cols_1, lines_1;	/* for efficiency's sake */
extern int line0, col0;		/* origin of input line */
extern int metakey;
extern char clreoln[], clreoscr[], begoln[], modenorm[];
extern char key_left[], key_right[], key_up[], key_down[];

void set_terminal();
void reset_terminal();
void set_spec_keys();
void settermcap();
void keypad_bindings();
void default_bindings();
void gotoxy();
void optmove();
void moveto();
void lastline();
void show_footnote();
void clear_footnote();
void clearinpline();
void redraw_input();
void deletechars();
void insertchars();
void newline();
void attr_string();
void mark_and_print();
char *wrap_out();
void winchsig();

/* macros to find cursor position from input buffer position */
#define CURLINE(pos) (((pos) + col0) / cols_1 + line0)
#define CURCOL(pos) (((pos) + col0) % cols_1)

#define COLOURS 8		/* number of ANSI colours */
#define NOATTRIB COLOURS	/* no colour change, use default */
#define BOLD (COLOURS + 1)
#define UNDERLINE (COLOURS + 2)
#define INVERSE (COLOURS + 3)

/* constructors / accessors for attribute codes */
#define ATTRCODE(fg, bg) ((fg) | ((bg << 8)))
#define FOREGROUND(attrcode) ((attrcode) & 0xff)
#define BACKGROUND(attrcode) ((attrcode) >> 8)

#define NOATTRCODE ATTRCODE(NOATTRIB, NOATTRIB)

/*
 * NCSA telnet 2.2 doesn't reset the colour when it receives "esc [ m",
 * so we must know what the normal colours are in order to reset it.
 * These colours can be changed with the #stdcolour command.
 */
#ifdef TELNETBUG
#define DEFAULTFG 7		/* make default white text */
#define DEFAULTBG 4		/* on blue background */
#endif
